﻿namespace jello
{
    delegate int CommandCode(string[] vals, ref InternalState state);

    class Command
    {
        private short _Vals = 0;
        private string _Name = "";
        private CommandCode _Code;

        public int Run(string[] vals, ref InternalState state)
        {
            return _Code(vals, ref state);
        }

        public Command(string name, short vals, CommandCode code)
        {
            _Code = code;
            _Vals = vals;
            _Name = name;
        }

        public short NumberOfValues
        {
            get { return _Vals; }
        }

        public string Name
        {
            get { return _Name; }
        }
    }
}
